clear all; clc;

fin=fopen('Hill_RPT_30062011.xls');
buffer = fgetl(fin);  

% dataNN blir en m*6 matrise:
% 1=Ned: 2=Head: 3=Etta: 4=Q: 5=Qed: 6=Ted
data16=readData(15, fin); data14=readData(15, fin);
data13=readData(15, fin);  data12=readData(15, fin);
data11=readData(15, fin);  data10=readData(15, fin);
data9=readData(15, fin);  data8=readData(15, fin);
data6=readData(15, fin); 

LINESPEC=cellstr(['-k+'; '-ko'; '-k*'; '-k.'; '-kx'; '-kx'; '-kd'; '-k^'; '-kv'; '-k<'; '-k>'; '-kp'; '-kh';]);
fontSizeLabel=14; fontSizeAxes=14; fontweight='bold';
tickNed=[0.7 0.8 0.9 1.0 1.1 1.2 1.3]; tickQed=tickNed; tickTed=[-0.5 0 0.5 1.0 1.5 2 ];
tickH=[0.9 1.0 1.1 1.2]; tickQ=[-0.5 0 0.5 1 1.5];

BEP=10; bestAlfa=data10;
NedStar=bestAlfa(BEP,1); QedStar=bestAlfa(BEP,5); TedStar=bestAlfa(BEP,6); H_Star=bestAlfa(12,2); Q_Star=bestAlfa(BEP,4); ettaStar=bestAlfa(BEP,3);

figure(1); clf; axes('fontSize', fontSizeAxes, 'fontWeight', fontweight)%, 'XTick', tickNed, 'YTick', tickQed);
hold on;
X=1; Y=5; dX=1; dY=1; textPosition=[0.4 0];
plot(data16(:,X)/dX, data16(:,Y)/dY, LINESPEC{1}); plot(data14(:,X)/dX, data14(:,Y)/dY, LINESPEC{2});
plot(data13(:,X)/dX, data13(:,Y)/dY, LINESPEC{3}); plot(data12(:,X)/dX, data12(:,Y)/dY, LINESPEC{4});
plot(data11(:,X)/dX, data11(:,Y)/dY, LINESPEC{5}); plot(data10(:,X)/dX, data10(:,Y)/dY, LINESPEC{6});
plot(data9(:,X)/dX, data9(:,Y)/dY, LINESPEC{7}); plot(data8(:,X)/dX, data8(:,Y)/dY, LINESPEC{8});
plot(data6(:,X)/dX, data6(:,Y)/dY, LINESPEC{9});
text(textPosition(1),textPosition(2),['Qed*=', num2str(QedStar)],'fontSize' , fontSizeLabel, 'fontWeight', fontweight); 
text(textPosition(1),textPosition(2)-0.15,['Ned*=', num2str(NedStar)],'fontSize' , fontSizeLabel, 'fontWeight', fontweight); 
xlabel('Dimensionless speed Ned [-]', 'fontSize' , fontSizeLabel ) ; ylabel('Dimensionless flow Qed [-]', 'fontSize' , fontSizeLabel);
legend('\alpha=16', '\alpha=14', '\alpha=13', '\alpha=12' , '\alpha=11', '\alpha=10', '\alpha=9', '\alpha=8' , '\alpha=6', 'Location', 'SouthEast', 'Orientation','vertical'); legend('boxoff'); 
 axis([0.20 0.27 0.08 0.19 ])

figure(2); clf; axes('fontSize', fontSizeAxes, 'fontWeight', fontweight)%, 'XTick', tickNed, 'YTick', tickQed); 
hold on;
X=1; Y=3; dX=1; dY=1; textPosition=[0.25 90.7];
plot(data16(:,X)/dX, data16(:,Y)/dY, LINESPEC{1}); plot(data14(:,X)/dX, data14(:,Y)/dY, LINESPEC{2});
plot(data13(:,X)/dX, data13(:,Y)/dY, LINESPEC{3}); plot(data12(:,X)/dX, data12(:,Y)/dY, LINESPEC{4});
plot(data11(:,X)/dX, data11(:,Y)/dY, LINESPEC{5}); plot(data10(:,X)/dX, data10(:,Y)/dY, LINESPEC{6});
plot(data9(:,X)/dX, data9(:,Y)/dY, LINESPEC{7}); plot(data8(:,X)/dX, data8(:,Y)/dY, LINESPEC{8});
plot(data6(:,X)/dX, data6(:,Y)/dY, LINESPEC{9});
text(textPosition(1),textPosition(2)-0.4,['\eta*=', num2str(ettaStar)],'fontSize' , fontSizeLabel, 'fontWeight', fontweight); 
text(textPosition(1),textPosition(2),['Ned*=', num2str(NedStar)],'fontSize' , fontSizeLabel, 'fontWeight', fontweight); 
xlabel('Dimensionless speed Ned/Ned* [-]', 'fontSize' , fontSizeLabel ) ; ylabel('Efficiency  \eta [%]', 'fontSize' , fontSizeLabel);
legend('\alpha=16', '\alpha=14', '\alpha=13', '\alpha=12' , '\alpha=11', '\alpha=10', '\alpha=9', '\alpha=8' , '\alpha=6', 'Location', 'NorthEast'); legend('boxoff');  axis([0.19 0.30 86.5 91 ])

NN=30; x=linspace(0.2, 0.27 , NN);
n=zeros(NN,9); q=n; e=n;

varnames=[16 14 13 12 11 10 9 8 6]; N_Alfa=9;
for i=1:N_Alfa
data=eval(['data', num2str(varnames(i))]);  
q(:,i)=interp1(data(:,1), data(:,5), x,'cubic' ,'extrap');
e(:,i)=interp1(data(:,1), data(:,3),x,'cubic' ,'extrap'); 
end

N=zeros(NN,NN); Q=N; E=Q;

for i=1:NN
N(:,i)=x;
Q(i,:)=linspace(0.19, 0.08, NN);
E(i,:)=interp1(q(i,:), e(i,:),Q(i,:),'cubic' ,'extrap'); 
end

contourLevels=[90.5 90.0 89.5 89 88 87];
figure(1);
[C,h]=contour(N, Q, E, contourLevels)
set(h,'LineStyle','-','LineColor','k') 
clabel(C, h, 'manual','fontSize' , fontSizeLabel, 'fontWeight', fontweight)

